﻿using System;

using DevExpress.XtraBars.Docking;
using DevExpress.XtraEditors;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            DockManager dockManager = new DockManager(this);

            DockPanel panel1 = dockManager.AddPanel(DockingStyle.Left );
            DockPanel panel2 = dockManager.AddPanel(DockingStyle.Right);

            panel1.Text = "패널 1";
            panel2.Text = "패널 2";

            dockManager.RegisterDockPanel += dockManager_RegisterDockPanel;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 도킹 관리자 도킹 패널 등록하기 - dockManager_RegisterDockPanel(sender, e)

        /// <summary>
        /// 도킹 관리자 도킹 패널 등록하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void dockManager_RegisterDockPanel(object sender, DockPanelEventArgs e)
        {
           if(e.Panel.Count != 0 && e.Panel.Tabbed == true)
           {
                foreach(DockPanel dockPanel in e.Panel.Controls)
                {
                    dockPanel.Tag = dockPanel.TabText = dockPanel.Text;

                    dockPanel.Text = "[탭] " + dockPanel.Text;

                    dockPanel.DockChanged += dockPanel_DockChanged;
                }
            }
        }

        #endregion
        #region 도킹 패널 도킹 변경시 처리하기 - dockPanel_DockChanged(sender, e)

        /// <summary>
        /// 도킹 패널 도킹 변경시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void dockPanel_DockChanged(object sender, EventArgs e)
        {
            DockPanel dockPanel = sender as DockPanel;

            if(dockPanel.IsTab == false)
            {
                dockPanel.Text = dockPanel.Tag.ToString();

                dockPanel.DockChanged -= dockPanel_DockChanged;
            }
        }

        #endregion
    }
}